<template>
  <div class="flex-row align-items-center">
    <div class="container">
      <b-row class="justify-content-center" style="position: fixed;  top: 50%;  left: 50%;  transform: translate(-50%, -50%);">
        <b-card no-body class="mx-4">
          <b-card-body class="p-4" style="width: 52rem ">
            <b-form>
              <h1>Sign up</h1>
              <p class="text-muted">New account</p>

              <b-input-group class="mb-3">
                <b-input-group-prepend>
                  <b-input-group-text>@</b-input-group-text>
                </b-input-group-prepend>
                <b-form-input :state="validateEmail" type="email" v-model="email" class="form-control" placeholder="Email"
                              autocomplete="email"/>
                <b-form-invalid-feedback id="input-live-feedback2">
                  The email is not valid.
                </b-form-invalid-feedback>
              </b-input-group>

              <b-input-group class="mb-3">
                <b-input-group-prepend>
                  <b-input-group-text><i class="icon-lock"></i></b-input-group-text>
                </b-input-group-prepend>
                <b-form-input :state="firstPass" type="password" v-model="password" class="form-control" placeholder="Password"
                              autocomplete="new-password"/>
                <b-form-invalid-feedback id="input-live-feedback3">
                  Password must have at least 6 characters, an uppercase, lowercase and numbers.
                </b-form-invalid-feedback>
              </b-input-group>

              <b-input-group class="mb-4">
                <b-input-group-prepend>
                  <b-input-group-text><i class="icon-lock"></i></b-input-group-text>
                </b-input-group-prepend>
                <b-form-input :state="secondPass" @keypress.enter="register()" type="password" v-model="password_confirmation" class="form-control"
                              placeholder="Repeat password" autocomplete="new-password"/>
                <b-form-invalid-feedback id="input-live-feedback4">
                  Passwords don't match.
                </b-form-invalid-feedback>
              </b-input-group>

              <a style="color: red;">{{ error_output }}</a>

              <b-button @click="register" variant="success" block>Sign up</b-button>
            </b-form>
          </b-card-body>
        </b-card>
      </b-row>
    </div>
  </div>
</template>


<script>
  export default {
    name: "Register",
    computed: {
      validateEmail() {
        return /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(this.email);
      },
      firstPass() {
        if (this.password.length < 6){
          return false;
        }else{
          return /[A-Z]/.test(this.password) && /[a-z]/.test(this.password) && /[0-9]/.test(this.password);
        }
      },
      secondPass() {
        return this.password === this.password_confirmation;
      }
    },
    data() {
      return {
        email: "",
        password: "",
        password_confirmation: "",
        error_output: ""
      };
    },
    methods: {
      finalValidation: function () {
        return !!(this.firstPass && this.secondPass && this.validateEmail);
      },
      register: function () {
        let data = {
          "email": this.email,
          "pass": this.password
        };
        if (!this.finalValidation()){
          this.error_output = "The email is not valid."
        }
        else if (this.password === this.password_confirmation) {
          this.$store
            .dispatch("register", data)
            .then(() => this.$router.push("/Login"))
            .catch(err => console.log(err));
        } else {
          this.error_output = "Passwords don't match."
        }
      }
    }
  }
</script>
